/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.disk.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import vip.xiaonuo.common.enums.CommonSortOrderEnum;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.page.CommonPageRequest;
import vip.xiaonuo.disk.domain.Chapter;
import vip.xiaonuo.disk.mapper.ChapterMapper;
import vip.xiaonuo.disk.param.ChapterAddParam;
import vip.xiaonuo.disk.param.ChapterEditParam;
import vip.xiaonuo.disk.param.ChapterIdParam;
import vip.xiaonuo.disk.param.ChapterPageParam;
import vip.xiaonuo.disk.service.ChapterService;

import java.util.List;

/**
 * 课程章节表Service接口实现类
 *
 * @author pans
 * @date  2025/07/02 15:34
 **/
@Service
public class ChapterServiceImpl extends ServiceImpl<ChapterMapper, Chapter> implements ChapterService {


    @Override
    public Page<Chapter> page(ChapterPageParam chapterPageParam) {
        QueryWrapper<Chapter> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isAllNotEmpty(chapterPageParam.getSortField(), chapterPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(chapterPageParam.getSortOrder());
            queryWrapper.orderBy(true, chapterPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(chapterPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(Chapter::getId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(ChapterAddParam chapterAddParam) {
        Chapter chapter = BeanUtil.toBean(chapterAddParam, Chapter.class);
        this.save(chapter);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(ChapterEditParam chapterEditParam) {
        Chapter chapter = this.queryEntity(chapterEditParam.getId());
        BeanUtil.copyProperties(chapterEditParam, chapter);
        this.updateById(chapter);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<ChapterIdParam> chapterIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(chapterIdParamList, ChapterIdParam::getId));
    }

    @Override
    public Chapter detail(ChapterIdParam chapterIdParam) {
        return this.queryEntity(chapterIdParam.getId());
    }

    @Override
    public Chapter queryEntity(Integer id) {
        Chapter chapter = this.getById(id);
        if(ObjectUtil.isEmpty(chapter)) {
            throw new CommonException("课程章节表不存在，id值为：{}", id);
        }
        return chapter;
    }

}
